<?php
/*
Plugin Name: Jump-to
Plugin URI: http://www.urbangiraffe.com/plugins/jumpto
Version: 1.0
Description: Uses post meta-data to add a drop-down page selection box to posts.  Ideally suited for multi-page messages, but could equally be used to add a 'jump-to' feature to anything.
Author: John Godley
Author URI: http://www.urbangiraffe.com
*/

function jumpTo ($text)
{
  if (is_single () || is_page ())
  {
    $extra = "";
    $list = get_post_custom_values ("jumpto");
    if (count ($list) > 0)
    {
      $vals = explode ("\r\n", $list[0]);
      if (count ($vals) > 0)
      {
        global $page;
        
        $extra = 'Jump to: <select id="jumpto" name="jumpto" size="1" onchange="document.location.href=this.options[selectedIndex].value">';
        foreach ($vals AS $val)
        {
          $split = explode ('=', $val);
          if (count ($split) == 2)
          {
            $sel = "";
            if ($page == $split[0])
              $sel = 'selected="selected"';
              
            if ('' == get_settings('permalink_structure'))
              $extra .= "<option $sel value=\"".get_permalink ()."&amp;page=$split[0]\">".htmlspecialchars ($split[1])."</option>";
            else
              $extra .= "<option $sel value=\"".get_permalink ()."$split[0]\">".htmlspecialchars ($split[1])."</option>";
          }
        }

        $extra .= "</select>";
      }
    }
    return $text.$extra;
  }
  return $text;
}

# Set the filter hook to the callback function
add_filter('the_content', 'jumpTo');
?>